Welcome -*- text -*- :-> to the move portion of the FW-macro package for
THE, the Hessling Editor


WHAT IT IS
----------

This portion of the FW-macros handles the moving of cursor or text in
THE. The way how lineends are handled is different to the way of
moving in plain THE. It's more like moving in WordStar-compatible
editors - the cursor will wrap at eol/bol to the next/previous
line.

Normally, these macros should be assigned to keys. Within FW-macros
there are two ways, depending on wether you use FW-macros in their
plain form (WordStar-like) or in compatibility mode
(THE/XEDIT/KEDIT-like). In general you are completely free to use your
own definitions.

This portion of FW-macros should work on WIN32, OS/2 and X11. It is
possible that it works on other systems too.


WHAT YOU NEED
-------------

o a THE version as new as 2.5 (Nov 16th 1997)
o a REXX-system
o a file system with the capability of long filenames
o Info-Zip's Unzip 5.0 or equivalent to unzip this archive
o some free space on disk (some 10kB) for the files and some time to spend
* optional: the other parts of FW-macros


DISCLAIMER & COPYRIGHT
----------------------

This portion of FW-macros is protected by copyright (C) 1993-1998 to
Franz-Josef Wirtz.

The whole macro- and batch-package with all its files is free
software; you can redistribute it and/or modify it under the terms of
the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or any later version.

All these macros, batches, menu- and helpfiles from the package are
distributed in the hope that they will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with this macro; if not, write to:

   The Free Software Foundation, Inc.
   675 Mass Ave,
   Cambridge, MA 02139 USA.


INSTALLATION (OS/2)
-------------------

1) Install THE as described there, i.e. setup the environment variables
   THE_HOME_DIR and THE_MACRO_PATH.

2) If you want to make use of the FW-macros in general, install the
   package as described there. If not, just proceed.

3) Unpack the files -

3a) if you use other FW-macros:
    place the files in THE_FW_HOME. (Do not set the environment
    variable THE_FW_HOME unless you have the base set of FW-macros. As
    soon as this variable is set, some macros behave slightly different.)

3b) if you don't use FW-macros in general:
    place the files somewhere in your THE_MACRO_PATH.

4) Before you start editing, you might think of (re)defining some keys
   to call the macros. But you can do this also after you've started
   editing.

5) Here we are:-), just start editing. Load a file into the editor and
   try out the keys you've defined. Move left/right a char, a word a
   paragraph, to bol/to eol, to top/bottom of screen. Mark a block
   somewhere, scroll it ot of sight, eventually edit another dir and
   then locate back the block.

6) Write comments and questions to me, invent new macros, menus, help
   files...., read the docs for corrections etc. Feel free to contact
   me. Send a postcard of your hometown, a picture from you, some
   lyrics... 

EXAMPLES FOR KEY DEFINITIONS
----------------------------
Within FW-macros:

os = version.3()
select
 when (os == "OS2") then
 do
    env = "OS2ENVIRONMENT"
    dirsep = "\"
 end
 when (os == "WIN32") then
 do
    env = "SYSTEM"
    dirsep = "\"
 end
 otherwise
 do
    env = "ENVIRONMENT"
    dirsep = "/"
 end
end
tmp = value( 'TMP', , env)
if (tmp = "") then
   tmp = ""
else
   tmp = tmp""dirsep
call value 'THE_FW_UNDELBLOCK_KEY', 'C-F8',       env
call value 'THE_FW_LINEMARK',       'HORIZONTAL', env

/* moving of cursor */
'define CURL    macro larrow'
'define CURR    macro rarrow'
'define C-S     macro larrow'
'define C-D     macro rarrow'
'define C-CURL  macro wordleft'
'define C-CURR  macro wordright'
'define C-A     macro wordleft'
'define C-F     macro wordright'
'define HOME    macro bol'
'define END     macro eol'
'define C-HOME  macro scrntop'
'define C-END   macro scrnbot'
"define C-F3    macro prevpara"
"define C-F4    macro nextpara"

/* scrolling operations  (cursor should stay at position in file) */
'define F1     macro scrolldn'
'define F2     macro scrollup'
'define C-Z    macro scrollup'
'define A-CURU macro scrolldn'
'define C-W    macro scrolldn'
'define A-CURD macro scrollup'
'define F3     macro scrollright 4'
'define F4     macro scrollleft 4'
'define A-CURL macro scrollright'
'define A-CURR macro scrollleft'


Keydefinitions compatible to THE/KEDIT/XEDIT

'define C-F5     macro gocurr'
"define S-F8     macro nextpara"
'define C-CURU   macro prevpara'
'define A-CURU   macro scrollup'
'define C-CURD   macro nextpara'
'define A-CURD   macro scrolldn'
'define CURL     macro larrow'
'define C-CURL   macro wordleft'
'define A-CURL   macro scrollright'
'define CURR     macro rarrow'
'define C-CURR   macro wordright'
'define A-CURR   macro scrollleft'
'define A-END    macro bol'
'define A-PGUP   macro scrntop'
'define A-PGDN   macro scrnbot'
'define A-F1     macro goblock BOB'
'define A-F2     macro goblock EOB'


TRAPS AND HINTS
---------------
See the file 'fw_move.hlp'


MANIFEST OF FILES
-----------------
### Info files
COPYING          - GNU General Public License
README.move      - this file
fw_move.hlp      - help file for the moving FW-macros
		 
### macros	 
larrow           - move left, at bol to eol of previous line
rarrow           - move right, at eol to bol of next line
wordleft         - move to next word left, wrap at bol
wordright        - move to next word right, wrap at eol
bol              - move to beginning of line
eol              - move to end of line
scrntop          - move to top line of text window
scrnbot          - move to bottom line of text window
prevpara         - move to previous paragraph (sep. by empty lines)
nextpara         - move to next paragraph (sep. by empty lines)
goblock          - move to block in any file (use BOB or EOB) as argument

/* scrolling operations  (cursor should stay at position in file) */
scrolldn         - scroll down
scrollup         - scroll up
scrollright      - scroll right (optional parameter: number of columns)
scrollleft       - scroll left (optional parameter: number of columns)

All these macros are only usefull when assigned to a key.

CONTACT
-------
Author of this package:

Franz-Josef Wirtz,
Juelicher Str. 299,         email: fjw@ecotopia.oche.de
D-52070 Aachen,
Germany

You can also contact Mark Hessling, but he's only maintaining the
sources of THE, not these macros. Any contributors are welcome.

Mark Hessling                   Email:             M.Hessling@qut.edu.au
PO Box 203                      Phone:                    +617 3802 0800
Bellara                         http://www.gu.edu.au/gext/the/markh.html
QLD 4507                        **** Maintainer PDCurses & REXX/SQL ****
Australia                       ************* Author of THE ************

There are also mailing lists talking about THE, REXX and XEDIT and
clones in general. See the documentation for THE.

WHERE TO GET THE
----------------
THE is available from the following sites:

 North America:  ftp://uiarchive.cso.uiuc.edu/pub/packages/THE/
                 http://uiarchive.cso.uiuc.edu/
                 ftp://ftp.xylogics.com/pub/misc/THE/
 Germany:        ftp://ftp.rzg.mpg.de/pub/software/the/THE/
                 ftp://ftp.germany.eu.net/pub/comp/sysv/THE/
 Austria:        ftp://ftp.wu-wien.ac.at/pub/src/Editors/THE/
 Australia:      ftp://ftp.qut.edu.au/pub/markh/THE/
                 http://www.gu.edu.au/gext/the/markh.html

Files available:

thedos??.zip            - version ?.? DOS executable and documentation
thedjg??.zip            - version ?.? extended DOS executable and documentation
theos2??.zip            - version ?.? OS/2 executable and documentation
thew32??.zip            - version ?.? Win95/NT executable and documentation
thesrc??.zip            - source code for version ?.?
THE-?.?.tar.gz          - source code for version ?.?
thedoc??.zip            - HTML documentation for version ?.?

thedit21.zip            - version 2.1 MS-Windows 3.1 port (shareware)

The version placeholder ?? should be replaced by 24 or higher.

MANY THANKS TO
--------------
... you for trying this package

... Mark Hessling for his work done on THE and his help in
    developing this macro package.


TIMESTAMP: 14. January 1998
---------

Now enjoy
Franz-Josef
